<script setup lang="ts">
import { useRoleStore } from '@/stores/role'
import { useUserStore } from '@/stores/user'
import { computed, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import ProfileView from './ProfileView.vue'
import EditeUserCard from '@/views/User/EditeUserCard.vue'
import UserFilterDialog from '@/views/User/UserFilterDialog.vue'
import { useAuthStore } from '@/stores/auth'
import type { User } from '@/types/User'

const users = computed(() => userStore.users)
const refForm = ref<VForm | null>(null)
const userStore = useUserStore()
const roleStore = useRoleStore()

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await userStore.saveUser()
  userStore.closeDialog()
}

const sortedUsers = computed(() => {
  return userStore.users.slice().sort((a: User, b: User) => {
    if (a.id !== undefined && b.id !== undefined) {
      return a.id - b.id
    }
    // Handle the case where 'id' is undefined for some items
    return 0
  })
})

onMounted(async () => {
  userStore.branchFil = useAuthStore().getCurrentUser()!.branch.name
  await userStore.getUsers()
  await roleStore.getRoles()
})
</script>

<template>
  <div>
    <v-sheet>
      <v-row>
        <v-col cols="12">
          <v-container fluid>
            <v-toolbar flat>
              <v-toolbar-title>User Management</v-toolbar-title>
              <v-divider class="mx-4" inset vertical></v-divider>
              <v-spacer></v-spacer>
              <v-btn size="40px" prepend-icon="mdi-filter-outline" class="mr-5" @click="userStore.filterDialog = true">
                <!-- New User -->
              </v-btn>
              <v-dialog v-model="userStore.dialog" persistent width="1024">
                <template v-slot:activator="{ props }">
                  <v-btn size="40px" v-bind="props" prepend-icon="mdi-plus-thick" class="mr-5"
                    @click="userStore.newUser = true">
                    <!-- New User -->
                  </v-btn>
                </template>
                <EditeUserCard></EditeUserCard>
              </v-dialog>
              <v-dialog v-model="userStore.dialogDelete" max-width="500px">
                <v-card>
                  <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn variant="text" @click="userStore.closeDelete">Cancel</v-btn>
                    <v-btn variant="text" @click="userStore.deleteItemConfirm">OK</v-btn>
                    <v-spacer></v-spacer>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </v-toolbar>

            <v-table fixed-header height="530">
              <thead>
                <tr>
                  <th>Id</th>
                  <th>รูปภาพ</th>
                  <th>ชื่อ</th>
                  <th>Email</th>
                  <th>ตำหน่ง</th>
                  <th>สาขา</th>
                  <th>Action</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="item in sortedUsers" :key="item.id">
                  <td>{{ item.id }}</td>
                  <td>
                    <v-img :src="'http://localhost:3000/images/users/' + item.image" width="100" rounded></v-img>
                  </td>
                  <td>{{ item.name }}</td>
                  <td>{{ item.email }}</td>
                  <td>{{ item.role.name }}</td>
                  <td>{{ item.branch.name }}</td>
                  <td>
                    <v-icon size="small" class="me-2" @click="userStore.profileOpen(item)">
                      mdi-account
                    </v-icon>
                    <v-icon size="small" @click="userStore.deleteItem(item)"> mdi-delete </v-icon>
                  </td>
                </tr>
              </tbody>

              <template v-if="!users.length">
                <v-btn @click="userStore.getUsers()"> Reset </v-btn>
              </template>
            </v-table>
          </v-container>
        </v-col>
      </v-row>

      <v-dialog v-model="userStore.profileDialog" max-width="1024px">
        <div class="d-flex align-center justify-end" style="padding-right: 5px; padding-top: 5px">
          <v-btn @click="userStore.closeProfile" color="red-darken-4" icon="mdi-close-circle" size="small"></v-btn>
        </div>
        <profile-view></profile-view>
      </v-dialog>
      <v-dialog v-model="userStore.filterDialog" max-width="500px">
        <user-filter-dialog></user-filter-dialog>
      </v-dialog>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
